// offline1.cpp : Defines the entry point for the console application.

#include "stdafx.h"
#include <fstream>
#include <stdio.h>
#include <iostream>
#include <vector>
#include <map>
#include <stdlib.h>
#include <time.h>
#include <ctime>
#include <algorithm>
#include <set>

using namespace std;
bool test = 0;
int info = 0;
double testweight = 0;
int numCar = 10;
int MAX_CARC = 95;
int offline = 0; //0 = online, 1 = offline


void loadPlan(map<int,double> &plans){
	ifstream plan;
	plan.open("..\\Data\\Plan.prn");
	if (!plan) {
	cerr << "Unable to open file Plan.prn";
	exit(1);   // call system to stop
	}
	std::string id;
	//Remove headers
	for(int i = 0; i <= 4; i++){
		plan >> id;
	//	std::cout << id << " ";
	}
	int temp, tempNumber, tempAmount;
	while(plan >> temp){
		plan >> tempNumber;
		plan >> temp;
		plan >> temp;
		plan >> tempAmount;
		plans[tempNumber] += tempAmount;
		//cout << productMap[ID]->getName() << " " << productMap[ID]->getPrice() << "\n";
	}
	plan.close();

}

void loadCuttingPattern(int &nCp, 
						int &nAnimal, 
						std::map<int,CutPattern*> &cpMap, 
						std::map<int,Animal*> &animalMap, 
						std::map<int,Product*> &productMap){
	using namespace std;
	ifstream skareMonster;
	skareMonster.open("..\\Data\\SkareMonster.prn");
	if (!skareMonster) {
		cerr << "Unable to open file SkareMonster.prn";
		exit(1);   // call system to stop
	}
	std::string id;
	for(int i = 0; i <= 4; i++){
		skareMonster >> id;
	//	std::cout << id << " ";
	}
	int lastCp = -1;
	int thisCp;
	int output;
	int lastAnimal = -1;
	int thisAnimal;
	int fat;
	double amount;
	while(skareMonster >> thisCp){
		
		skareMonster >> output;
		skareMonster >> thisAnimal;
		skareMonster >> fat;
		skareMonster >> amount;
		if(lastAnimal != thisAnimal){
			animalMap[thisAnimal] = new Animal();
			lastAnimal = thisAnimal;
			nAnimal++;
		}
		if(thisCp != lastCp){
			lastCp = thisCp;
			
			cpMap[thisCp] = new CutPattern(thisCp);
			animalMap.find(thisAnimal)->second->addCutPattern( cpMap.find(thisCp)->second );
			nCp++;
		}

		if(!productMap.count(output)){
			cout << "ERROR: Product not found";
		}
		
		cpMap.find(thisCp)->second->addOutput(output,amount);
	}
	skareMonster.close();
}

void loadPrices(std::map<int,Product*> &productMap){
	using namespace std;
	ifstream prices;
	prices.open("..\\Data\\Varepriser.prn");
	if (!prices) {
		cerr << "Unable to open file Varepriser.prn";
		exit(1);   // call system to stop
	}
	std::string temp;
	for(int i = 0; i < 3; i++){
		prices >> temp;
	}
	int ID;
	std::string n;
	double p;
	while(prices >> ID){
		productMap[ID] = new Product();
		prices >> n;
		productMap[ID]->setName(n);
		prices >> p;
		productMap[ID]->setPrice(p);
		//cout << productMap[ID]->getName() << " " << productMap[ID]->getPrice() << "\n";
	}
	prices.close();
}

void loadCarcasses(std::vector<int> &carcasses,std::vector<double> &weight,int &nCa){
	using namespace std;
	ifstream carc;
	carc.open("..\\DataSlaktedeDyr.prn");
	if (!carc) {
		cerr << "Unable to open file SlaktedeDyr.prn";
		exit(1);   // call system to stop
	}
	std::string temp;
	int temp2;
	double w;
	for(int i = 0; i < 6; i++){
		carc >> temp;
	}
	while(carc >> temp){
		nCa++;
		carc >> temp2;
		carcasses.push_back(temp2);
		carc >> temp;
		carc >> w;
		weight.push_back(w);
		carc >> temp;
		carc >> temp;
	}
	carc.close();
}

void loadCarcasses2(std::vector<int> &carcasses,std::vector<double> &weight,int &nCa){
	using namespace std;
	ifstream carc;
	std::vector<int> shuffle;
	std::vector<int> carcTemp;
	std::vector<double> weightTemp;
	carc.open("..\\Data\\Inntak.prn");
	if (!carc) {
		cerr << "Unable to open file Inntak.prn";
		exit(1);   // call system to stop
	}
	std::string temp;
	int temp2;
	double w;
	for(int i = 0; i < 6; i++){
		carc >> temp;
	}
	while(carc >> temp){
		shuffle.push_back(nCa);
		nCa++;
		carc >> temp2;
		carcTemp.push_back(temp2);
		carc >> temp;
		carc >> temp;
		carc >> temp;
		carc >> w;
		weightTemp.push_back(w);	
	}
	//Randomise the order in a deterministic way
	
	srand(0);
	//random_shuffle(shuffle.begin(),shuffle.end());
	for(int i = 0; i < shuffle.size() && i < MAX_CARC;i++){
		carcasses.push_back(carcTemp[shuffle[i]]);
		weight.push_back(weightTemp[shuffle[i]]);
	}
	
	
	
	carc.close();
}


double calcValue(std::map<int,CutPattern*> &cpMap, 
				 std::vector<double> &weight, 
				 std::vector<int> &pattern,
				 std::map<int,Product*> &productMap,
				 std::map<int,Animal*> &animalMap, 
				 std::vector<int> &carcasses,
				 std::map<int,double> &plans,
				 map<int,double> &produced
				 ){
	
	double value = 0;
	double value2 = 0;
	CutPattern* tempPat;
	produced.clear();
	for(int i = 0; i < (int)pattern.size(); i++){
		std::set<CutPattern*>::iterator tempIte = animalMap.find(carcasses[i])->second->cpSet.begin();
		
		for(int l = 0; l < pattern[i];l++){
			tempIte ++;
		}
		tempPat = *tempIte;
		double tempWeight;
		double tempAmount;
		for(int j = 0; j < (int)tempPat->product_Vector.size();j++){
			tempWeight = weight[i];
			tempAmount = tempPat->amount_Vector[j];
			produced[tempPat->product_Vector[j]] += tempWeight * tempAmount;
		}
	}
	//Calculate the value of the products
	std::map<int,Product*>::iterator prodIte = productMap.begin();
	double nonZero;
	
	while(prodIte != productMap.end()){
		value += (*prodIte).second->getPrice() * std::min(produced[(*prodIte).first],plans[(*prodIte).first]);
		value += ( ((*prodIte).second->getPrice()*0.6-5.0) ) * std::max( (produced[(*prodIte).first] - plans[(*prodIte).first]) ,0.0);
		value -= (*prodIte).second->getPrice() *(plans[(*prodIte).first]-std::min(produced[(*prodIte).first],plans[(*prodIte).first]));
		prodIte++;
	}

	return value;
}

void sortPopulation(std::vector<std::vector<int>> &population, vector<double> &popValue){
	//Simple sorting based on selection sort, should be reimplemented with a better sorting algorithm for large populations	
	std::vector<std::vector<int>> population2;
	vector<double> popValue2;
	std::vector<bool> swapped;
	for(int i = 0; i < (int)popValue.size();i++){
		swapped.push_back(0);
	}
	for(int i = 0; i < (int)popValue.size();i++){
		double largest = 0;
		int position = 0;
		for(int j = 0; j < (int)popValue.size();j++ ){
			if(popValue[j] > largest && !swapped[j]){
				largest = popValue[j];
				position = j;
			}
		}
		population2.push_back(population[position]);
		popValue2.push_back(largest);
		swapped[position] = 1;
	}
	population.swap(population2);
	popValue.swap(popValue2);
}


void geneticSearch(std::map<int,CutPattern*> &cpMap, 
				 std::vector<double> &weight, 
				 std::vector<int> &pattern,
				 std::map<int,Product*> &productMap,
				 std::map<int,Animal*> &animalMap, 
				 std::vector<int> &carcasses,
				 std::map<int,double> &plans,
				 int numPat,
				 map<int,double> &produced){
				
	std::vector<std::vector<int>> population;

	//Generating population
	//population.push_back(vector<int>);
	population.push_back(pattern);
	for(int j = 0; j < 499; j++){
		std::vector<int> CutPlan;
		for(int i = 0; i < (int)pattern.size(); i++){

			numPat = animalMap.find(carcasses[i])->second->getSize();
			CutPlan.push_back(rand()%numPat);
		}
		population.push_back(CutPlan);
	}
	//Calculating the quality of the people in the population
	vector<double> popValue;
	for(int i = 0; i < (int)population.size(); i++){
		//Might be a good idea to have popValue as double
		popValue.push_back(calcValue(cpMap,weight, population[i], 
			productMap, animalMap, carcasses, plans, produced));
	}
	//Sorting the population
	sortPopulation(population,popValue);

	std::vector<std::vector<int>> population2;
	for(int i = 0; i < 40; i++){

		int surv = 100;
		//The best survives
		for(int j = 0; j < surv; j++){
			population2.push_back(population[j]);
		}
		//Children are born
		for(int j = 0; j < 200; j++){
			int person1 = rand()%surv;
			int person2 = rand()%surv;
			vector<int> newPerson;
			for(int k = 0; k < (int)population[0].size();k++){
				if(rand()%2 >= 1){
					newPerson.push_back((population[person1])[k]);
				}
				else{
					newPerson.push_back((population[person2])[k]);
				}
			}
			population2.push_back(newPerson);
		}
		//Mutations
		for(int j = 0; j < 50; j++){
			int person1 = rand()%surv;
			vector<int> newPerson;
			for(int k = 0; k < (int)population[0].size();k++){
				if(rand()%10 >= 7){

					numPat = animalMap.find(carcasses[k])->second->getSize();
					newPerson.push_back(rand()%numPat);	
				}
				else{
					newPerson.push_back((population[person1])[k]);
				}
			}
			population2.push_back(newPerson);

		}
		//Newborns are born
		for(int j = 0; j < 50; j++){
	
			vector<int> newPerson;
			for(int k = 0; k < (int)population[0].size();k++){
				numPat = animalMap.find(carcasses[k])->second->getSize();
				newPerson.push_back(rand()%numPat);	
			}
			population2.push_back(newPerson);

		}
		
		population.swap(population2);
		population2.clear();
		popValue.clear();
		if(info >= 4){
			cout << "Pop size" << population.size() <<"\n";
		}
		for(int j = 0; j < (int)population.size(); j++){
			//cout << j;
			popValue.push_back(calcValue(cpMap,weight, population[j], 
			productMap, animalMap, carcasses, plans, produced));
		}
		sortPopulation(population,popValue);
	}
	pattern = population[0];
}


void localSearch(std::map<int,CutPattern*> &cpMap, 
				 std::vector<double> &weight, 
				 std::vector<int> &pattern,
				 std::map<int,Product*> &productMap,
				 std::map<int,Animal*> &animalMap, 
				 std::vector<int> &carcasses,
				 std::map<int,double> &plans,
				 int numPat,
				 map<int,double> &produced
				 ){
	using namespace std;

	int change = 1;
	int bestTemp = 0;
	double bestVal = 0;
	double curTemp = 0;
	while(change){
		change = 0;

		bestVal = calcValue(cpMap, weight, pattern, productMap, animalMap, carcasses,plans, produced);
		for(int i = 0; i < (int)pattern.size();i++){
			
			numPat = animalMap.find(carcasses[i])->second->getSize();

			bestTemp = pattern[i];
			for(int j = 0; j < numPat; j++){

				
				pattern[i] = (pattern[i]+1)%numPat;
				curTemp = calcValue(cpMap, weight, pattern, productMap, animalMap, carcasses,plans, produced);
				if(curTemp > bestVal){
					change = 1;

					bestTemp = pattern[i];
					bestVal = curTemp;
				}
			}	
			pattern[i] = bestTemp;
		}
		curTemp = calcValue(cpMap, weight, pattern, productMap, animalMap, carcasses,plans, produced);
	
	}
}
//Calculate the value of historical data of real production
double exValue(std::map<int,Product*> &productMap, std::map<int,double> &plans){
	ifstream ex;
	double value = 0;
	ex.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\Program\\Data\\Produksjon.prn");
	
	
	if (!ex) {
		cerr << "Unable to open file Produksjon.prn";
		exit(1);   // call system to stop
	}
	std::string temp;
	int temp2;
	double w;
	double totalWeight = 0;
	map<int,double> produced;
	for(int i = 0; i < 4; i++){
		ex >> temp;
	}
	while(ex >> temp2){
		ex >> temp;
		ex >> temp;
		ex >> w;
		
		//cout << " w " <<w << " temp " << temp2 << "\n";
		produced[temp2] += w;
		//value += ((productMap.find(temp2))->second)->getPrice() * w;
		totalWeight += w;
	}
	cout << "w " << totalWeight << "\n";
	ex.close();
	double nonZero;
	//Calculate the value of the products
	std::map<int,Product*>::iterator prodIte = productMap.begin();
	while(prodIte != productMap.end()){
		//nonZero = std::max( ((*prodIte).second->getPrice()*0.6-5) ,0.0);

		value += (*prodIte).second->getPrice() * std::min(produced[(*prodIte).first],plans[(*prodIte).first]);
		// *0.6-5 used for value-adjustment of products not in the plan
		value += (( (*prodIte).second->getPrice()*0.6-5.0 ) * std::max( (produced[(*prodIte).first] - plans[(*prodIte).first]) ,0.0));
		if(produced[(*prodIte).first] > 0){
			cout << "Ex. produced " << produced[(*prodIte).first] << " kg of "<< prodIte->first << "\n";
		}
		prodIte++;
		
	}


	return value;
}


int main(int argc, char* argv[]){   
	using namespace std;

	int nCp = 0;
	int nAnimal = 0;
	int nCa = 0;
	map<int,CutPattern*> cpMap;
	map<int,Animal*> animalMap;
	map<int,Product*> productMap;
	//Vector with the carcass type of incoming carcasses
	vector<int> carcasses;
	//Vector with the weight of the carcasses in the carcass vector
	vector<double> weight;
	vector<int> pattern;
	map<int,double> plan;
	map<int,double> tempPlan;
	map<int,double> produced;
	vector<int> history;
	map<int,double> totalProd;
	clock_t start, finish;
	double time;
	double totalWeight = 0;

	if(argc == 2){
		numCar = atoi(argv[1]);
	}
	cout << "Measured carcasses: " << numCar << "\n";
	if(info >= 1){
		cout << "Loading prices...";
	}
	start = clock();
	loadPrices(productMap);
	finish = clock();
	time = (double(finish)-double(start))/CLOCKS_PER_SEC;
	if(info >= 1){
		cout << " " << time << " seconds \n";
		cout << "Loading cutting patterns...";
	}
	start = clock();
	loadCuttingPattern(nCp, nAnimal,cpMap,animalMap, productMap);
	finish = clock();
	time = (double(finish)-double(start))/CLOCKS_PER_SEC;
	if(info >= 1){
		cout << " " << time << " seconds \n";
		cout << "Loading carcasses...";
	}
	start = clock();

	loadCarcasses2(carcasses,weight,nCa);
	finish = clock();
	time = (double(finish)-double(start))/CLOCKS_PER_SEC;
	if(info >= 1){
		cout << " " << time << " seconds \n";
		cout << "Loading production plan...";
	}
	start = clock();
	loadPlan(plan);
	finish = clock();
	time = (double(finish)-double(start))/CLOCKS_PER_SEC;
	
	start = clock();
	int numPat = 0;

	srand(5);

	int animNumb = 0;
	if(offline == 1){
		cout << "Offline optimisation\n";
		for(int i = 0; i < (int)carcasses.size() && i < MAX_CARC;i++){

			numPat = animalMap.find(carcasses[i])->second->getSize();
			pattern.push_back(rand()%numPat);
		}
		//localSearch(cpMap, weight, pattern, productMap, 
		//			animalMap, carcasses, plan, numPat, totalProd);
		geneticSearch(cpMap, weight, pattern, productMap, 
					animalMap, carcasses, plan, numPat, totalProd);
			cout << "TOT "<< calcValue(	cpMap, 
					weight, 
					pattern,
					productMap,
					animalMap, 
					carcasses,
					plan,
					totalProd
				 );
		localSearch(cpMap, weight, pattern, productMap, 
					animalMap, carcasses, plan, numPat, totalProd);
			cout << "TOT "<< calcValue(	cpMap, 
					weight, 
					pattern,
					productMap,
					animalMap, 
					carcasses,
					plan,
					totalProd
				 );
		cout << calcValue(cpMap, weight, pattern, productMap, animalMap, carcasses,plan, produced);	
		cout << pattern.size();
		for(int i = 0; i < pattern.size(); i++){
			std::set<CutPattern*>::iterator tempIte = animalMap.find(carcasses[i])->second->cpSet.begin();
			for(int l = 0; l < pattern[i];l++){
				tempIte++;
			}
			cout << "Use pattern: "<< (*tempIte)->name << " on carcass " << i <<"\n";
		}
		map<int,Product*>::iterator prodIte = productMap.begin();
		double totalValue = 0;
	}
	else if(offline == 0){
		while(carcasses.size() >= 1){
			pattern.clear();
			animNumb++;

			std::map<int,double>::iterator planIte = plan.begin();
			tempPlan.clear();
			//Adjusts how much of the production should be made by the measured carcasses
			while(planIte != plan.end()){
				tempPlan[planIte->first] = (planIte->second - totalProd[planIte->first])  /   (((numCar>(int)carcasses.size())?(double)numCar:(double)carcasses.size())  /(double)numCar);//  *(1+ ((((double)numCar-(numCar>(int)carcasses.size())?(double)numCar:(double)carcasses.size())  /(double)numCar))*((((double)numCar-(numCar>(int)carcasses.size())?(double)numCar:(double)carcasses.size())  /(double)numCar))*0.5   );
				if(tempPlan[planIte->first] < 0){
					tempPlan[planIte->first] = 0;
				}
				if(info >= 3){
					cout << "Real plan: " << planIte->second << "\n";
					cout << "Temp plan: " << tempPlan[planIte->first] << "\n";
					cout << "Total production: " <<  totalProd[planIte->first]<< " " << numCar << " " << carcasses.size()<< " " << 10000*((double)((double)numCar / ((numCar>(int)carcasses.size())?(double)numCar:(double)carcasses.size()))) <<"\n";
				}
				planIte++;
			}

			//Assign a random cutting pattern to each carcass
			for(int i = 0; i < (int)carcasses.size() && i < numCar;i++){

				numPat = animalMap.find(carcasses[i])->second->getSize();
				pattern.push_back(rand()%numPat);
			}
			
			start = clock();
		
			localSearch(cpMap, weight, pattern, productMap, 
						animalMap, carcasses, tempPlan, numPat, produced);
		
			finish = clock();
			time = (double(finish)-double(start))/CLOCKS_PER_SEC;

			cout << " " << time << " seconds \n";

			std::set<CutPattern*>::iterator tempIte = animalMap.find(carcasses[0])->second->cpSet.begin();
			//Might be much easier to just write tempIte += l;
			for(int l = 0; l < pattern[0];l++){
				tempIte++;
			}
			cout << "Use pattern: "<< (*tempIte)->name << " on carcass " << animNumb <<"\n";
			history.push_back((*tempIte)->name);
			for(int j = 0; j < (int)(*tempIte)->product_Vector.size();j++){
				double tempWeight = weight[0];
				double tempAmount = (*tempIte)->amount_Vector[j];
				//This might be a slow look-up
				totalProd[(*tempIte)->product_Vector[j]] += tempWeight * tempAmount;
			}
			carcasses.erase(carcasses.begin());
			testweight += weight.front();
			weight.erase(weight.begin());

		}
	}

	map<int,Product*>::iterator prodIte = productMap.begin();
	double totalValue = 0;
	
	while(prodIte != productMap.end()){
		if(totalProd[prodIte->first]>0){
			cout << prodIte->first << " has been produced " << totalProd[prodIte->first] << " kg of.\n";
		}
		totalWeight +=totalProd[(*prodIte).first];
		totalValue += (*prodIte).second->getPrice() * std::min(totalProd[(*prodIte).first],plan[(*prodIte).first]);
		totalValue += (( (*prodIte).second->getPrice()*0.6-5.0 ) * std::max( (totalProd[(*prodIte).first] - plan[(*prodIte).first]) ,0.0));
		totalValue -= (*prodIte).second->getPrice() *(plan[(*prodIte).first]-std::min(totalProd[(*prodIte).first],plan[(*prodIte).first]));
		prodIte++;
	}
	cout << "Testweight: "<< testweight <<"\n";
	cout << "Total value is: " << totalValue;
	cout << "Total weight is: " << totalWeight;
return 0;
}